#!/usr/bin/env python
import pygtk
import sys
import os
pygtk.require('2.0')

import gtk
import gnomeapplet
import time



target = os.getenv("HOME")
my_import = 'capture.png'
capture_file = ''
capture_direct = ''
size = 'portion'
arg = ''

def set_size_crop(*arguments, **keywords):
	global size
	size = 'portion'

def set_size_full(*arguments, **keywords):
	global size
	size = 'fullscreen'

def set_capture_name(*arguments, **keywords):
	global capture_file

	capture_file =  os.popen('zenity --text "Capture\'s name :" --title "Capture\'s name :" --entry --entry-text "capture.png"').read()
	capture_file = capture_file.replace('\n','')

def set_direct_name(*arguments, **keywords):
	global capture_direct

	capture_direct =  os.popen('zenity --title "Directory"  --file-selection --directory').read()
	capture_direct = capture_direct.replace('\n','')

def menu (applet):
	propxml="""
		<popup name="button3">
		<menuitem name="Item 3" verb="full" label="_Fullscreen" pixtype="stock" pixname="gtk-cut"/>
		<menuitem name="Item 4" verb="crop" label="_Portion of screen" pixtype="stock" pixname="gtk-fullscreen"/>
		<menuitem name="Item 5" verb="name" label="_Set capture's name" />
		<menuitem name="Item 6" verb="direct" label="_Set directory" />		
		</popup>
		"""
	verbs = [("full", set_size_full),("crop", set_size_crop),("name", set_capture_name),("direct", set_direct_name)]
	applet.setup_menu(propxml, verbs, None)

def sample_factory(applet, iid):
	
        event_box = gtk.EventBox()
        applet.add(event_box)
        event_box.show()

	image = gtk.Image()
	image.set_from_stock("gtk-cut",gtk.ICON_SIZE_BUTTON)
        event_box.add(image)
        image.show()

        event_box.connect("button-press-event", previous_clicked,applet)

	applet.show_all()
	return True

def previous_clicked(self,event,applet):
	global capture_file,capture_direct,size,arg,my_import,target

	if capture_file:
		my_import = capture_file

	if capture_direct:
		target = capture_direct

	if event.type == gtk.gdk.BUTTON_PRESS and event.button == 3:
		menu(applet)
	else:
		if (size == 'fullscreen'):
			arg = '-window root '

		print "import "+arg+" "+target+"/"+my_import
		#avoid unable to grab mouse error		
		time.sleep(1)
		os.system("import "+arg+" "+target+"/"+my_import)

if len(sys.argv) == 2:
	if sys.argv[1] == "run-in-window":
		main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		main_window.set_title("Python Applet")
		main_window.connect("destroy", gtk.main_quit)
		app = gnomeapplet.Applet()
		sample_factory(app, None)
		app.reparent(main_window)
		main_window.show_all()
		gtk.main()
		sys.exit()

gnomeapplet.bonobo_factory("OAFIID:GNOME_ScreenSt_Factory",gnomeapplet.Applet.__gtype__,"Take screenshot", "1.0", sample_factory)
